## libvigraimpex 1.11.1%2Bdfsg

=== test/blockwisealgorithms/CMakeLists.txt ===
VIGRA_CONFIGURE_THREADING()

if(THREADING_FOUND)
    VIGRA_ADD_TEST(test_blockwiselabeling test_labeling.cxx LIBRARIES ${THREADING_LIBRARIES})
    VIGRA_ADD_TEST(test_blockwisewatersheds test_watersheds.cxx LIBRARIES ${THREADING_LIBRARIES})
    VIGRA_ADD_TEST(test_blockwiseconvolution test_convolution.cxx LIBRARIES ${THREADING_LIBRARIES})
else()
    MESSAGE(STATUS "** WARNING: No threading implementation found.")
    MESSAGE(STATUS "**          test_blockwiselabeling will not be executed on this platform.")
    MESSAGE(STATUS "**          test_blockwisewatersheds will not be executed on this platform.")
    MESSAGE(STATUS "**          test_blockwiseconvolution will not be executed on this platform.")
endif()

=== test/correlation/CMakeLists.txt ===
if(FFTW3_FOUND)
    INCLUDE_DIRECTORIES(${SUPPRESS_WARNINGS} ${FFTW3_INCLUDE_DIR})

    VIGRA_CONFIGURE_THREADING()

    VIGRA_ADD_TEST(test_correlation test.cxx LIBRARIES ${FFTW3_LIBRARIES} ${FFTW3F_LIBRARIES} ${THREADING_LIBRARIES})
else()
    MESSAGE(STATUS "** WARNING: fftw not found. test_correlation will not be executed")
endif()

=== test/features/CMakeLists.txt ===
if(FFTW3_FOUND)
    INCLUDE_DIRECTORIES(${SUPPRESS_WARNINGS} ${FFTW3_INCLUDE_DIR})

    VIGRA_ADD_TEST(test_features test.cxx LIBRARIES vigraimpex ${FFTW3_LIBRARIES})

    # VIGRA_COPY_TEST_DATA(ghouse.gif)
else()
    MESSAGE(STATUS "** WARNING: test_features will not be executed")
endif()

=== test/filters/CMakeLists.txt ===
VIGRA_ADD_TEST(test_filters test.cxx)

=== test/gridgraph/CMakeLists.txt ===
VIGRA_ADD_TEST(test_gridgraph test.cxx)

if(WITH_BOOST_GRAPH)
    VIGRA_ADD_TEST(test_gridgraph_BGL test.cxx LIBRARIES ${Boost_GRAPH_LIBRARY})
    INCLUDE_DIRECTORIES(${SUPPRESS_WARNINGS} ${Boost_INCLUDE_DIR})
    SET_TARGET_PROPERTIES(test_gridgraph_BGL PROPERTIES COMPILE_FLAGS "-DWITH_BOOST_GRAPH")
endif()

if(WITH_LEMON)
    VIGRA_ADD_TEST(test_gridgraph_LEMON test.cxx LIBRARIES ${LEMON_LIBRARY})
    INCLUDE_DIRECTORIES(${SUPPRESS_WARNINGS} ${LEMON_INCLUDE_DIR})
    SET_TARGET_PROPERTIES(test_gridgraph_LEMON PROPERTIES COMPILE_FLAGS "-DWITH_LEMON")
endif()

=== test/sampler/CMakeLists.txt ===
VIGRA_ADD_TEST(test_sampler test.cxx)

=== test/sifImport/CMakeLists.txt ===
if(HDF5_FOUND)
    INCLUDE_DIRECTORIES(${SUPPRESS_WARNINGS} ${HDF5_INCLUDE_DIR})

    ADD_DEFINITIONS(-DHasHDF5 ${HDF5_CPPFLAGS})
endif()

VIGRA_ADD_TEST(test_sifImport test.cxx LIBRARIES vigraimpex)
VIGRA_COPY_TEST_DATA(testSif_4_16_30001.sif testSif_4_13_30000.sif testSif_4_6_30000.sif testSif_forBlocks_4_16_30001.sif)

=== debian/control ===
Source: libvigraimpex
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Andreas Metzler <ametzler@debian.org>
Section: libs
Priority: optional
Build-Depends: cmake,
               debhelper-compat (= 12),
               dh-python,
               libboost-python-dev,
               libfftw3-dev,
               libhdf5-dev,
               libjpeg-dev,
               libopenexr-dev,
               libpng-dev,
               libtiff5-dev,
               python3-dev,
               python3-nose,
               python3-numpy,
               libboost-thread-dev
Build-Depends-Indep: doxygen,
                     ghostscript,
                     python3,
                     python3-sphinx,
                     texlive-latex-base,
                     texlive-latex-extra
Rules-Requires-Root: no
Standards-Version: 4.4.1
Vcs-Browser: https://salsa.debian.org/science-team/libvigraimpex
Vcs-Git: https://salsa.debian.org/science-team/libvigraimpex.git
Homepage: https://ukoethe.github.io/vigra/

Package: libvigraimpex-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libfftw3-dev,
         libhdf5-dev,
         libjpeg-dev,
         libpng-dev,
         libtiff5-dev,
         libvigraimpex11 (= ${binary:Version}),
         ${misc:Depends}
Suggests: libvigraimpex-doc
Description: development files for the C++ computer vision library
 Vision with Generic Algorithms (VIGRA) is a computer vision library
 that puts its main emphasis on flexible algorithms, because
 algorithms represent the principle know-how of this field. The
 library was consequently built using generic programming as
 introduced by Stepanov and Musser and exemplified in the C++ Standard
 Template Library. By writing a few adapters (image iterators and
 accessors) you can use VIGRA's algorithms on top of your data
 structures, within your environment.
 .
 This package contains the header and development files needed to
 build programs and packages using VIGRA.

Package: libvigraimpex11
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: C++ computer vision library
 Vision with Generic Algorithms (VIGRA) is a computer vision library
 that puts its main emphasis on flexible algorithms, because
 algorithms represent the principle know-how of this field. The
 library was consequently built using generic programming as
 introduced by Stepanov and Musser and exemplified in the C++ Standard
 Template Library. By writing a few adapters (image iterators and
 accessors) you can use VIGRA's algorithms on top of your data
 structures, within your environment.

Package: libvigraimpex-doc
Architecture: all
Section: doc
Depends: ${misc:Depends}
Suggests: libvigraimpex-dev,
          python-vigra-doc
Description: Documentation for the C++ computer vision library
 Vision with Generic Algorithms (VIGRA) is a computer vision library
 that puts its main emphasis on flexible algorithms, because
 algorithms represent the principle know-how of this field. The
 library was consequently built using generic programming as
 introduced by Stepanov and Musser and exemplified in the C++ Standard
 Template Library. By writing a few adapters (image iterators and
 accessors) you can use VIGRA's algorithms on top of your data
 structures, within your environment.
 .
 This package contains documentation for the VIGRA library.

Package: python3-vigra
Architecture: any
Section: python
Depends: libvigraimpex11 (= ${binary:Version}),
         ${misc:Depends},
         ${python3:Depends},
         ${shlibs:Depends}
Suggests: python3-h5py,
          python-vigra-doc
Description: Python3 bindings for the C++ computer vision library
 Vision with Generic Algorithms (VIGRA) is a computer vision library
 that puts its main emphasis on flexible algorithms, because
 algorithms represent the principle know-how of this field. The
 library was consequently built using generic programming as
 introduced by Stepanov and Musser and exemplified in the C++ Standard
 Template Library. By writing a few adapters (image iterators and
 accessors) you can use VIGRA's algorithms on top of your data
 structures, within your environment.
 .
 This package exports the functionality of the VIGRA library to Python3.

Package: python-vigra-doc
Architecture: all
Section: doc
Depends: ${misc:Depends},
         ${sphinxdoc:Depends}
Suggests: libvigraimpex-doc,
          python3-vigra
Description: Documentation for Python3 bindings for the C++ computer vision library
 Vision with Generic Algorithms (VIGRA) is a computer vision library
 that puts its main emphasis on flexible algorithms, because
 algorithms represent the principle know-how of this field. The
 library was consequently built using generic programming as
 introduced by Stepanov and Musser and exemplified in the C++ Standard
 Template Library. By writing a few adapters (image iterators and
 accessors) you can use VIGRA's algorithms on top of your data
 structures, within your environment.
 .
 This package contains documentation for Python3 bindings for the VIGRA library.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/architecture.mk

export DEB_BUILD_MAINT_OPTIONS   = hardening=+bindnow

export DEB_LDFLAGS_MAINT_APPEND  = -Wl,--as-needed
DEB_CFLAGS_MAINT_APPEND   = -Wall -pipe
DEB_CXXFLAGS_MAINT_APPEND = -Wall -pipe
PYTHONVERSIONNUMBER = $(subst python,,$(shell py3versions -d))

AMCONFBUILDINDEP := $(shell if dh_listpackages | grep -q libvigraimpex-doc ; \
	then echo withindep ; \
	else echo archonly ; fi )
MAINBDIR = obj.$(DEB_TARGET_MULTIARCH)
MAINBDIRO = -O--builddirectory=$(MAINBDIR)

# support for Ubuntu development
# # Add -O2 at end to verride -O3 default setting
ifeq ($(DEB_HOST_ARCH),ppc64el)
	DEB_CFLAGS_MAINT_APPEND += -O2
	DEB_CXXFLAGS_MAINT_APPEND += -O2
endif

# fixing floating-point rounding errors on i386 CPUs, see #820429
ifneq (,$(filter $(DEB_HOST_ARCH_CPU), i386))
  DEB_CFLAGS_MAINT_APPEND += -ffloat-store
  DEB_CXXFLAGS_MAINT_APPEND += -ffloat-store
endif

# build with Boost.Thread on armel, see #814606
ifeq ($(DEB_HOST_ARCH),armel)
  CMAKE_EXTRAS := -DWITH_BOOST_THREAD=1
  # not set by VigraDetectThreading.cmake
  DEB_CXXFLAGS_MAINT_APPEND += -std=c++11
endif

ifneq (,$(filter $(DEB_BUILD_ARCH),mips mipsel))
  DEB_CXXFLAGS_MAINT_APPEND += --param ggc-min-expand=20
endif

export DEB_CFLAGS_MAINT_APPEND
export DEB_CXXFLAGS_MAINT_APPEND

ifneq ($(wildcard /usr/lib/$(DEB_HOST_MULTIARCH)/hdf5/serial/libhdf5.so),)
  export CMAKE_INCLUDE_PATH=/usr/include/hdf5/serial
  export CMAKE_LIBRARY_PATH=/usr/lib/$(DEB_HOST_MULTIARCH)/hdf5/serial
endif

override_dh_auto_configure:
	dh_auto_configure --verbose $(MAINBDIRO) -- \
		-DLIB_SUFFIX="/$(DEB_HOST_MULTIARCH)/" \
		-DWITH_OPENEXR=ON \
		-DPYTHON_EXECUTABLE=/usr/bin/python3 \
		-DPYTHON_INCLUDE_DIR=/usr/include/python$(PYTHONVERSIONNUMBER) \
		$(CMAKE_EXTRAS)
	find $(MAINBDIR)/vigranumpy/ -name 'link.txt' -exec sed -i \
		-e 's/ -lpython[0-9.]\+ / /g' \
		-e '/-Wl,-soname,vigranumpycore/b' \
		-e 's/ -Wl,-soname,[^ ]\+ / /' {} +

override_dh_auto_build:
	@echo DEBUGMEMSIZE ; if which free ; then free ; fi
	dh_auto_build --verbose $(MAINBDIRO)
ifeq ($(filter archonly,$(AMCONFBUILDINDEP)),)
	$(MAKE) doc_cpp -C $(MAINBDIR)/
	ln -sf $(CURDIR)/vigranumpy/docsrc/c_api_replaces.txt \
		$(MAINBDIR)/vigranumpy/docsrc/
	$(MAKE) doc_python -C $(MAINBDIR)
endif

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	sed -i 's/exit\ 1/exit\ 0/' \
		$(MAINBDIR)/test/multiarray/run_test_multiarray_chunked.sh #812852
	sed -i 's/-O2/-O2 -O0/' \
		$(MAINBDIR)/test/math/CMakeFiles/test_math.dir/flags.make #817840
	sed -i 's/-O2/-O2 -O1/' \
		$(MAINBDIR)/test/blockwisealgorithms/CMakeFiles/test_blockwiselabeling.dir/flags.make # https://github.com/ukoethe/vigra/issues/409
	sed -i 's/-O2/-O2 -O1/' \
		$(MAINBDIR)/test/blockwisealgorithms/CMakeFiles/test_blockwisewatersheds.dir/flags.make # https://github.com/ukoethe/vigra/issues/409, #853513
	sed -i 's/-O2/-O2 -O1/' \
		$(MAINBDIR)/test/gridgraph/CMakeFiles/test_gridgraph.dir/flags.make #871556
	sed -i 's/-O2/-O2 -O0/' \
		$(MAINBDIR)/test/multiarray/CMakeFiles/test_multiarray.dir/flags.make #872037
	$(MAKE) -C $(MAINBDIR) check
	$(MAKE) -C $(MAINBDIR) vigranumpytest
else
	@echo 'Not running testsuite, "nocheck" in $$DEB_BUILD_OPTIONS'
endif

override_dh_auto_install:
	dh_auto_install $(MAINBDIRO)

override_dh_install:
	find debian/tmp -type d -name doctrees -exec rm -rf {} +
	rm -vf debian/tmp/usr/doc/vigra/LICENSE.txt
	dh_install $(MAINBDIRO)
ifeq ($(filter archonly,$(AMCONFBUILDINDEP)),)
	cd debian/libvigraimpex-doc/usr/share/doc/libvigraimpex-dev/ && \
		rm -f html/jquery.js && \
		sed -r -i -e \
		's!(<a href=")LICENSE.txt(">)!\1/usr/share/doc/libvigraimpex-doc/copyright\2!g' \
		html/index.html
endif

override_dh_installdocs-indep:
	dh_installdocs
	# Cannot use dh $@ --with sphinxdoc since it is only available on
	# arch-all builds.
	dh_sphinxdoc

%:
	dh $@ --with python3,numpy3 --builddirectory=$(MAINBDIR) --no-parallel

## libvigraimpex 1.11.1+dfsg

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)

##################################################
#
#     basic initializations
#
##################################################

PROJECT(vigra)

# read the current version from config_version.hxx
file(READ ${vigra_SOURCE_DIR}/include/vigra/config_version.hxx VIGRA_VERSION_FILE)
string(REGEX MATCH "VIGRA_VERSION_MAJOR[ \t\n]+[^ \t\n]+" VIGRA_VERSION_MAJOR ${VIGRA_VERSION_FILE})
string(REGEX REPLACE "VIGRA_VERSION_MAJOR[ \t\n]" "" VIGRA_VERSION_MAJOR ${VIGRA_VERSION_MAJOR})
string(REGEX MATCH "VIGRA_VERSION_MINOR[ \t\n]+[^ \t\n]+" VIGRA_VERSION_MINOR ${VIGRA_VERSION_FILE})
string(REGEX REPLACE "VIGRA_VERSION_MINOR[ \t\n]" "" VIGRA_VERSION_MINOR ${VIGRA_VERSION_MINOR})
string(REGEX MATCH "VIGRA_VERSION_PATCH[ \t\n]+[^ \t\n]+" VIGRA_VERSION_PATCH ${VIGRA_VERSION_FILE})
string(REGEX REPLACE "VIGRA_VERSION_PATCH[ \t\n]" "" VIGRA_VERSION_PATCH ${VIGRA_VERSION_PATCH})

SET(vigra_version_short ${VIGRA_VERSION_MAJOR}.${VIGRA_VERSION_MINOR})
SET(vigra_version ${VIGRA_VERSION_MAJOR}.${VIGRA_VERSION_MINOR}.${VIGRA_VERSION_PATCH})
message(STATUS "Configuring VIGRA version ${vigra_version}")

SET(CMAKE_MODULE_PATH  ${CMAKE_MODULE_PATH}  ${vigra_SOURCE_DIR}/config)

include(VigraSetDefaults)
include(VigraCMakeUtils)
INCLUDE_DIRECTORIES(${vigra_SOURCE_DIR}/include)

if(SUPPRESS_3RD_PARTY_WARNINGS)
    set(SUPPRESS_WARNINGS SYSTEM)
endif()

IF(VIGRA_STATIC_LIB)
    SET(LIBTYPE STATIC)
    ADD_DEFINITIONS(-DVIGRA_STATIC_LIB)
ELSE(VIGRA_STATIC_LIB)
    SET(LIBTYPE SHARED)
ENDIF(VIGRA_STATIC_LIB)

IF (MSVC)
    ADD_DEFINITIONS(-D_CRT_SECURE_NO_DEPRECATE -D_SCL_SECURE_NO_DEPRECATE)
ENDIF ()

IF(CMAKE_CXX_COMPILER_ID MATCHES "(GNU|Clang)")
    set(SUFFICIENT_TEMPLATE_DEPTH FALSE)
    TRY_COMPILE(SUFFICIENT_TEMPLATE_DEPTH
                ${CMAKE_BINARY_DIR} ${PROJECT_SOURCE_DIR}/config/checkTemplateDepth.cxx
                COMPILE_DEFINITIONS "-DDEPTH=900")

    IF(SUFFICIENT_TEMPLATE_DEPTH)
        MESSAGE(STATUS "Checking template recursion depth: ok")
    ELSE()
        if(CMAKE_CXX_COMPILER_ID MATCHES "GNU")
            # As of cmake 2.8.10, there is a variable CMAKE_CXX_COMPILER_VERSION.
            # Emulate it by a compiler call if not present.
            IF(NOT CMAKE_CXX_COMPILER_VERSION)
                exec_program(${CMAKE_CXX_COMPILER}
                    ARGS ${CMAKE_CXX_COMPILER_ARG1} -dumpversion
                    OUTPUT_VARIABLE CMAKE_CXX_COMPILER_VERSION)
                string(REGEX REPLACE "([0-9])\\.([0-9])(\\.[0-9])?" "\\1.\\2"
                      CMAKE_CXX_COMPILER_VERSION ${CMAKE_CXX_COMPILER_VERSION})
            endif()

            message ("Detected GCC version ${CMAKE_CXX_COMPILER_VERSION}")
            if(CMAKE_CXX_COMPILER_VERSION VERSION_LESS "4.4.0")
                MESSAGE(WARNING "GNU c++ < 4.4 cannot build VIGRANumPy; disabling (found GCC ${CMAKE_CXX_COMPILER_VERSION})")
                SET(WITH_VIGRANUMPY 0)
            elseif(CMAKE_CXX_COMPILER_VERSION VERSION_LESS "4.5.0")
                # gcc 4.4.x syntax is -ftemplate-depth-900 (not =900)
                SET(CMAKE_CXX_FLAGS "-ftemplate-depth-900 ${CMAKE_CXX_FLAGS}")
                MESSAGE(STATUS "Checking template recursion depth: using -ftemplate-depth-900")
            else()
                # new syntax is =900, not -900
                SET(CMAKE_CXX_FLAGS "-ftemplate-depth=900 ${CMAKE_CXX_FLAGS}")
                MESSAGE(STATUS "Checking template recursion depth: using -ftemplate-depth=900")
            endif()
        else()
            # clang uses newer gcc syntax
            SET(CMAKE_CXX_FLAGS "-ftemplate-depth=900 ${CMAKE_CXX_FLAGS}")
            MESSAGE(STATUS "Checking template recursion depth: using -ftemplate-depth=900")
        endif()
    ENDIF()
ENDIF()

if(MSVC)
    string(REGEX MATCH "[0-9.]+" MSVC_VERSION ${CMAKE_GENERATOR})
endif()

if(MACOSX)
    set(CMAKE_MACOSX_RPATH 1)
endif()

##################################################
#
#     search for dependencies
#
##################################################

INCLUDE(VigraFindPackage)
VIGRA_FIND_PACKAGE(ZLIB)
VIGRA_FIND_PACKAGE(TIFF NAMES libtiff_i libtiff) # prefer DLL on Windows
VIGRA_FIND_PACKAGE(JPEG NAMES libjpeg)
VIGRA_FIND_PACKAGE(PNG)
VIGRA_FIND_PACKAGE(FFTW3 NAMES libfftw3-3 libfftw-3.3)
VIGRA_FIND_PACKAGE(FFTW3F NAMES libfftw3f-3 libfftwf-3.3)


IF(WITH_OPENEXR)
    VIGRA_FIND_PACKAGE(OpenEXR)
ENDIF()

IF(WITH_HDF5)
    VIGRA_FIND_PACKAGE(HDF5)
ENDIF()

IF(WITH_LEMON)
    VIGRA_FIND_PACKAGE(LEMON)
ENDIF()

SET(DOXYGEN_SKIP_DOT TRUE)
FIND_PACKAGE(Doxygen)

FIND_PACKAGE(PythonInterp ${PYTHON_VERSION})

##################################################
#
#     configure boost dependency
#
##################################################

set(WITH_BOOST "OFF")
set(BOOST_MINIMUM_VERSION "1.40.0")
set(WITH_BOOST_COMPONENTS "")

IF(WITH_BOOST_GRAPH)
    set(WITH_BOOST "ON")
ENDIF()

IF(WITH_VIGRANUMPY)
    set(WITH_BOOST "ON")
    # Do not add "python" to WITH_BOOST_COMPONENTS. It is more
    # reliabe to use 'FIND_LIBRARY' in FindVIGRANUMPY_DEPENDENCIES.
ENDIF()

IF(WITH_BOOST_THREAD)
    set(WITH_BOOST "ON")
    set(WITH_BOOST_COMPONENTS ${WITH_BOOST_COMPONENTS} thread system date_time chrono)
    set(BOOST_MINIMUM_VERSION "1.55.0")
ENDIF()

IF(WITH_BOOST)
    VIGRA_FIND_PACKAGE(Boost ${BOOST_MINIMUM_VERSION} COMPONENTS ${WITH_BOOST_COMPONENTS})
    # FIXME: the following may be unstable between cmake versions
    SET(Boost_LIB_SUFFIX "${_boost_COMPILER}${_boost_MULTITHREADED}-${Boost_LIB_VERSION}")
ENDIF()

if(WITH_BOOST AND Boost_FOUND)
    INCLUDE_DIRECTORIES(${SUPPRESS_WARNINGS} ${Boost_INCLUDE_DIR})
    IF(WITH_BOOST_THREAD)
        ADD_DEFINITIONS(-DUSE_BOOST_THREAD)
    ENDIF()
endif()

# Must be included AFTER boost is found.
include(VigraDetectThreading)
include(VigraConfigureThreading)

# Should come after VigraDetectThreading, since that updates the -std flag.
include(VigraDetectCppVersion)
VIGRA_DETECT_CPP_VERSION()

IF(WITH_VIGRANUMPY)
    FIND_PACKAGE(VIGRANUMPY_DEPENDENCIES)
ENDIF()

if(WITH_BOOST AND Boost_FOUND)
    # configure boost's autolink magic to use the right library name
    # (default on Windows is a mangled name like 'boost_system-vc110-mt-1_51.lib')
    if((Boost_SYSTEM_LIBRARY MATCHES "boost_system\\.lib") OR
       (Boost_PYTHON_LIBRARY MATCHES "boost_python\\.lib") OR
       (Boost_PYTHON_LIBRARY MATCHES "boost_python${PYTHON_VERSION_MAJOR}\\.lib"))
        set(Boost_MANGLED_NAMES 0)
        ADD_DEFINITIONS(-DBOOST_AUTO_LINK_NOMANGLE)
    else()
        set(Boost_MANGLED_NAMES 1)
    endif()
    if((Boost_SYSTEM_LIBRARY AND
        NOT Boost_SYSTEM_LIBRARY MATCHES "libboost_system") OR
       (Boost_PYTHON_LIBRARY AND
        NOT Boost_PYTHON_LIBRARY MATCHES "libboost_python"))
        ADD_DEFINITIONS(-DBOOST_ALL_DYN_LINK)
    endif()
endif()

IF(WITH_VALGRIND)
    FIND_PROGRAM(VALGRIND_EXECUTABLE valgrind)
ENDIF()

########################################
#  finalize compiler flags
SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS}"
    CACHE STRING  "Flags used by the C compiler during all build types" FORCE)
SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}"
    CACHE STRING  "Flags used by the C++ compiler during all build types" FORCE)

##################################################
#
#     setup testing environment
#
##################################################

ADD_CUSTOM_TARGET(check)
ADD_CUSTOM_TARGET(ctest COMMAND ${CMAKE_CTEST_COMMAND})

ADD_CUSTOM_TARGET(check_cpp)
ADD_DEPENDENCIES(check check_cpp)


OPTION(CREATE_CTEST_TARGETS "Create special targets for CTest" OFF)
IF(CREATE_CTEST_TARGETS)
  INCLUDE(CTest)
ENDIF()

IF(WITH_VIGRANUMPY)
    ADD_CUSTOM_TARGET(check_python)
    ADD_DEPENDENCIES(check check_python)
ENDIF()

ENABLE_TESTING()

##################################################
#
#     setup documentation generator
#
##################################################

ADD_CUSTOM_TARGET(doc)

# Automatically push the latest documentation to github's gh-pages.
# This only works when ${DOCDIR} refers to a VIGRA repository that is
# checked out in branch 'gh-pages', and the present repository is
# in branch 'master' (these conditions are checked in the script).
if(${CMAKE_SYSTEM_NAME} MATCHES "Linux")

    configure_file(${PROJECT_SOURCE_DIR}/config/update-gh-pages.sh.in
                   ${PROJECT_BINARY_DIR}/update-gh-pages.sh @ONLY)
    EXECUTE_PROCESS(COMMAND chmod u+x ${PROJECT_BINARY_DIR}/update-gh-pages.sh OUTPUT_QUIET ERROR_QUIET)

    ADD_CUSTOM_TARGET(gh-pages
          ${PROJECT_BINARY_DIR}/update-gh-pages.sh
          DEPENDS doc
          WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}
          COMMENT "Pushing documentation to github pages.")
endif()

##################################################
#
#     setup private experimentation target
#
##################################################

ADD_CUSTOM_TARGET(experiments)

##################################################
#
#     subdirectories
#
##################################################

ADD_SUBDIRECTORY(src)
ADD_SUBDIRECTORY(test)
ADD_SUBDIRECTORY(docsrc)

IF(WITH_VIGRANUMPY)
    ADD_SUBDIRECTORY(vigranumpy)
ENDIF()

IF(EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/private/CMakeLists.txt)
    ADD_SUBDIRECTORY(private EXCLUDE_FROM_ALL)
ENDIF()


set(LIB_SUFFIX "" CACHE STRING "Define suffix of lib directory name (32/64)" )

##################################################
#
#     global installation commands
#
##################################################

INSTALL(DIRECTORY ${PROJECT_SOURCE_DIR}/include/vigra
        DESTINATION include)

##################################################
#
#     enable CPack package generation
#
##################################################
INCLUDE(CPackConfig)

##################################################
#
#     add target vigra-$version-src.tar.gz
#
##################################################

find_program(GIT_EXECUTABLE
              NAMES git git.exe git.cmd
              HINTS $ENV{ProgramFiles}/Git/bin
              DOC "git command line client")

CONFIGURE_FILE(${PROJECT_SOURCE_DIR}/config/package-src.cmake.in
                ${PROJECT_BINARY_DIR}/package-src.cmake
                @ONLY IMMEDIATE)

add_custom_target(PACKAGE_SRC_TAR
                   COMMAND ${CMAKE_COMMAND} -P package-src.cmake
                   WORKING_DIRECTORY "${PROJECT_BINARY_DIR}"
                   COMMENT "Creating ${PROJECT_BINARY_DIR}/vigra-${vigra_version}-src.tar.gz")

ADD_DEPENDENCIES(PACKAGE_SRC_TAR check)
ADD_DEPENDENCIES(PACKAGE_SRC_TAR doc_cpp)
IF(WITH_VIGRANUMPY AND PYTHON_SPHINX)
    ADD_DEPENDENCIES(PACKAGE_SRC_TAR doc_python)
ENDIF()

##################################################
#
#  enable other non-CMake projects to find Vigra
#
##################################################

IF(NOT WIN32)
# vigra-config script for (non-CMake-based) third party packages
CONFIGURE_FILE(${PROJECT_SOURCE_DIR}/config/vigra-config.in
        ${PROJECT_BINARY_DIR}/bin/vigra-config
        @ONLY IMMEDIATE)
INSTALL(FILES ${PROJECT_BINARY_DIR}/bin/vigra-config
        DESTINATION bin
        PERMISSIONS
            OWNER_READ OWNER_WRITE OWNER_EXECUTE
            GROUP_READ GROUP_EXECUTE
            WORLD_READ WORLD_EXECUTE)
ENDIF(NOT WIN32)

##################################################
#
#     enable other CMake projects to find Vigra
#
##################################################

# config file for CMake FIND_PACKAGE command (for using the build tree)
CONFIGURE_FILE(${PROJECT_SOURCE_DIR}/config/VigraConfigBuild.cmake.in
        ${PROJECT_BINARY_DIR}/VigraConfig.cmake
        @ONLY IMMEDIATE)
CONFIGURE_FILE(${PROJECT_SOURCE_DIR}/config/VigraConfigVersion.cmake.in
        ${PROJECT_BINARY_DIR}/VigraConfigVersion.cmake
        @ONLY IMMEDIATE)

# config file for CMake FIND_PACKAGE command
CONFIGURE_FILE(${PROJECT_SOURCE_DIR}/config/VigraConfig.cmake.in
        ${PROJECT_BINARY_DIR}/lib/vigra/CMake/VigraConfig.cmake
        @ONLY IMMEDIATE)
CONFIGURE_FILE(${PROJECT_SOURCE_DIR}/config/VigraConfigVersion.cmake.in

=== test/classifier/CMakeLists.txt ===
if(HDF5_FOUND)
    INCLUDE_DIRECTORIES(${SUPPRESS_WARNINGS} ${HDF5_INCLUDE_DIR})
    ADD_DEFINITIONS(${HDF5_CPPFLAGS} -DHasHDF5)

    VIGRA_ADD_TEST(test_classifier test.cxx LIBRARIES vigraimpex ${HDF5_LIBRARIES})
    VIGRA_ADD_TEST(classifier_speed_comparison speed_comparison.cxx LIBRARIES ${HDF5_LIBRARIES})
else()
    MESSAGE(STATUS "** WARNING: test_classifier::RFHDF5Test() will not be executed")

    VIGRA_ADD_TEST(test_classifier test.cxx )
    VIGRA_ADD_TEST(classifier_speed_comparison speed_comparison.cxx)
endif()

add_subdirectory(data)

=== test/impex/CMakeLists.txt ===
IF(JPEG_FOUND)
  ADD_DEFINITIONS(-DHasJPEG)
ENDIF(JPEG_FOUND)

IF(PNG_FOUND)
  ADD_DEFINITIONS(-DHasPNG)
ENDIF(PNG_FOUND)

IF(TIFF_FOUND)
  ADD_DEFINITIONS(-DHasTIFF)
  INCLUDE_DIRECTORIES(${SUPPRESS_WARNINGS} ${TIFF_INCLUDE_DIR})
ENDIF(TIFF_FOUND)

IF(OPENEXR_FOUND)
  ADD_DEFINITIONS(-DHasEXR)
ENDIF(OPENEXR_FOUND)

VIGRA_ADD_TEST(test_impex test.cxx LIBRARIES vigraimpex)

VIGRA_COPY_TEST_DATA(lenna.xv lenna_gifref.xv lennafloat.xv lennafloatrgb.xv lennargb.xv no-image.txt lenna_0.tif lenna_1.tif lenna_2.tif lenna_masked_color.tif  lenna_masked_gray.tif bilevel.tiff)

=== test/merge_graph_adaptor/CMakeLists.txt ===
VIGRA_ADD_TEST(test_merge_graph_adaptor test.cxx)

=== test/multiarray/CMakeLists.txt ===
IF(JPEG_FOUND)
  ADD_DEFINITIONS(-DHasJPEG)
ENDIF(JPEG_FOUND)

IF(PNG_FOUND)
  ADD_DEFINITIONS(-DHasPNG)
ENDIF(PNG_FOUND)

IF(TIFF_FOUND)
  ADD_DEFINITIONS(-DHasTIFF)
ENDIF(TIFF_FOUND)

FILE(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/impex)

# Check cpp version
if(NOT ${VIGRA_CPP_VERSION})
    message(FATAL_ERROR
            "cmake error: VIGRA_CPP_VERSION not defined yet. "
            "Call VIGRA_DETECT_CPP_VERSION() from the main CMakeLists file." )
endif()

# multiarray/test.cxx uses 'auto' from c++11.
string(COMPARE LESS ${VIGRA_CPP_VERSION} "201103" NO_CXX11)
if(NO_CXX11 AND NOT MSVC) # Visual Studio 2010 and 2012 supports enough c++11 features that we can still use it
    MESSAGE(STATUS "** WARNING: You are compiling in C++98 mode.")
    MESSAGE(STATUS "**          Multiarray tests will be skipped.")
    MESSAGE(STATUS "**          Add -std=c++11 to CMAKE_CXX_FLAGS to enable multiarray tests.")
else()
    VIGRA_ADD_TEST(test_multiarray test.cxx LIBRARIES vigraimpex)
endif()

# Even with C++11, a working threading implementation is needed for running multiarray_chunked tests.
VIGRA_CONFIGURE_THREADING()

if(NOT THREADING_FOUND)
    MESSAGE(STATUS "** WARNING: Your compiler does not support C++ threading.")
    MESSAGE(STATUS "**          test_multiarray_chunked will not be executed on this platform.")
    if(NOT WITH_BOOST_THREAD)
        MESSAGE(STATUS "**          Try to run cmake with '-DWITH_BOOST_THREAD=1' to use boost threading.")
    endif()
else()
  SET(MULTIARRAY_CHUNKED_LIBRARIES ${THREADING_LIBRARIES})

  IF(HDF5_FOUND)
    ADD_DEFINITIONS(-DHasHDF5 ${HDF5_CPPFLAGS})
    INCLUDE_DIRECTORIES(${SUPPRESS_WARNINGS} ${HDF5_INCLUDE_DIR})
    SET(MULTIARRAY_CHUNKED_LIBRARIES vigraimpex ${HDF5_LIBRARIES} ${MULTIARRAY_CHUNKED_LIBRARIES})
  ELSE(TIFF_FOUND)
    SET(MULTIARRAY_CHUNKED_LIBRARIES vigraimpex ${MULTIARRAY_CHUNKED_LIBRARIES})
  ENDIF()

  VIGRA_ADD_TEST(test_multiarray_chunked test_chunked.cxx
                 LIBRARIES ${MULTIARRAY_CHUNKED_LIBRARIES})
endif()

=== test/permutation/CMakeLists.txt ===
VIGRA_ADD_TEST(test_permutation test.cxx LIBRARIES)

=== test/registration/CMakeLists.txt ===
VIGRA_CONFIGURE_THREADING()

if(FFTW3_FOUND)
    INCLUDE_DIRECTORIES(${SUPPRESS_WARNINGS} ${FFTW3_INCLUDE_DIR})
    ADD_DEFINITIONS(-DHasFFTW3)

    VIGRA_ADD_TEST(test_registration test.cxx LIBRARIES ${FFTW3_LIBRARIES} ${FFTW3F_LIBRARIES} ${THREADING_LIBRARIES} vigraimpex)
else()
    MESSAGE(STATUS "** WARNING: fftw not found. Fourier-domain registration tests will not be executed")

    VIGRA_ADD_TEST(test_registration test.cxx LIBRARIES ${THREADING_LIBRARIES} vigraimpex)
endif()

VIGRA_COPY_TEST_DATA(nuernberg-1991.png nuernberg-1995.png)

=== test/watersheds3d/CMakeLists.txt ===
VIGRA_ADD_TEST(test_watersheds3d test.cxx LIBRARIES vigraimpex)

=== vigranumpy/docsrc/CMakeLists.txt ===
IF(PYTHON_SPHINX)
    # vigranumpy documentation generation using sphinx
    IF(DEFINED VIGRANUMPY_DOCDIR)
        MESSAGE(SEND_ERROR "VIGRANUMPY_DOCDIR already defined! Please delete from Cache.")
    ENDIF()
    SET(VIGRANUMPY_DOCDIR ${DOCDIR}/vigranumpy)
    SET(SPHINX_OPTS ${SPHINX_OPTS} CACHE STRING
        "options passed to sphinx during vigranumpy doc generation"
        FORCE)
    IF(NOT DEFINED SPHINX_PAPER)
        SET(SPHINX_PAPER a4)
    ENDIF()
    SET(SPHINX_PAPER ${SPHINX_PAPER} CACHE STRING
        "Papersize for sphinx documentation generation (a4, letter)"
        FORCE)
    SET(SPHINX_ALLOPTS
        -d ${VIGRANUMPY_DOCDIR}/doctrees
        -D latex_paper_size=${SPHINX_PAPER}
        -c ${CMAKE_CURRENT_BINARY_DIR}
        ${SPHINX_OPTS})
    file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/_static)
    configure_file(_static/vigra-icon.ico ${CMAKE_CURRENT_BINARY_DIR}/_static/vigra-icon.ico COPYONLY)

    STRING(REGEX REPLACE "/vigra$" "" VIGRANUMPY_TMP_PATH ${vigranumpy_tmp_dir})

    if(CMAKE_MAJOR_VERSION LESS 3)
        DEPENDENCY_PATH(VIGRAIMPEX_PATH vigraimpex)
        CONFIGURE_FILE(
            ${CMAKE_CURRENT_SOURCE_DIR}/conf.py.cmake2.in
            ${CMAKE_CURRENT_BINARY_DIR}/conf.py
            @ONLY)
    else()
        CONFIGURE_FILE(
            ${CMAKE_CURRENT_SOURCE_DIR}/conf.py.in
            ${CMAKE_CURRENT_BINARY_DIR}/conf.py.in
            @ONLY)

        # two-stage file configuration is necessary because certain target
        # properties are only known at generation time (policy CMP0026)
        if(MSVC)
            file(GENERATE OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/conf.py
                          INPUT  ${CMAKE_CURRENT_BINARY_DIR}/conf.py.in
                          CONDITION $<CONFIG:Release>)
        else()
            file(GENERATE OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/conf.py
                          INPUT  ${CMAKE_CURRENT_BINARY_DIR}/conf.py.in)
        endif()
    endif()

    # VIGRA_CONFIGURATION is 'release' or 'debug' on Windows, nothing on Linux
    # variable CMAKE_CFG_INTDIR contains a dot '.' for a Windows nmake build, or
    #                           '$(OutDir)' for a VisualStudio build (OutDir will be
    #                           set by VS at build time)
    IF(CMAKE_CFG_INTDIR AND NOT CMAKE_CFG_INTDIR STREQUAL ".")
        SET(VIGRA_CONFIGURATION -D build_configuration=${CMAKE_CFG_INTDIR})
    ELSE()
        SET(VIGRA_CONFIGURATION)
    ENDIF()

    # just rerun sphinx (useful to debug the vigranumpy docu)
    ADD_CUSTOM_TARGET (doc_sphinx
        COMMAND ${CMAKE_COMMAND} -E make_directory
            ${VIGRANUMPY_DOCDIR}
        COMMAND ${PYTHON_SPHINX} -b html
            ${SPHINX_ALLOPTS}
            ${VIGRA_CONFIGURATION}
            ${CMAKE_CURRENT_SOURCE_DIR}
            ${VIGRANUMPY_DOCDIR}
        COMMENT "Generating vigranumpy documentation")

    # create vigranumpy documentation after updating C++ docu and vigranumpy modules
    ADD_CUSTOM_TARGET(doc_python
        COMMAND ${CMAKE_COMMAND} -E make_directory
            ${VIGRANUMPY_DOCDIR}
        COMMAND ${PYTHON_SPHINX} -b html
            ${SPHINX_ALLOPTS}
            ${VIGRA_CONFIGURATION}
            ${CMAKE_CURRENT_SOURCE_DIR}
            ${VIGRANUMPY_DOCDIR}
        COMMENT "Generating vigranumpy documentation")
    ADD_DEPENDENCIES(doc_python vigranumpy)
    ADD_DEPENDENCIES(doc_python doc_cpp)

ELSE(PYTHON_SPHINX)
    # no vigranumpy documentation if sphinx not available
    ADD_CUSTOM_TARGET (doc_python
        ${CMAKE_COMMAND} -E echo
        "Cannot generate Python documentation for vigranumpy. "
        "(sphinx-build not found)"
        VERBATIM)

ENDIF(PYTHON_SPHINX)

ADD_DEPENDENCIES(doc doc_python)

=== vigranumpy/src/CMakeLists.txt ===
VIGRA_CONFIGURE_THREADING()
SET(VIGRANUMPY_THREAD_LIBRARIES ${THREADING_LIBRARIES})

ADD_SUBDIRECTORY(core)

IF(FFTW3F_FOUND)
    ADD_SUBDIRECTORY(fourier)
ELSE()
    MESSAGE(STATUS "vigranumpy fourier module will not be built (fftw3f missing)")
ENDIF()

=== debian/control ===
--- 
+++ 
@@ -1,12 +1,12 @@
 Source: libvigraimpex
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
+Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
 Uploaders: Andreas Metzler <ametzler@debian.org>
 Section: libs
 Priority: optional
 Build-Depends: cmake,
-               debhelper-compat (= 12),
-               dh-python,
+               debhelper-compat (= 13),
+               dh-sequence-python3,
+               dh-sequence-numpy3,
                libboost-python-dev,
                libfftw3-dev,
                libhdf5-dev,
@@ -16,16 +16,16 @@
                libtiff5-dev,
                python3-dev,
                python3-nose,
-               python3-numpy,
                libboost-thread-dev
-Build-Depends-Indep: doxygen,
+Build-Depends-Indep: dh-sequence-sphinxdoc,
+                     doxygen,
                      ghostscript,
                      python3,
                      python3-sphinx,
                      texlive-latex-base,
                      texlive-latex-extra
 Rules-Requires-Root: no
-Standards-Version: 4.4.1
+Standards-Version: 4.5.1
 Vcs-Browser: https://salsa.debian.org/science-team/libvigraimpex
 Vcs-Git: https://salsa.debian.org/science-team/libvigraimpex.git
 Homepage: https://ukoethe.github.io/vigra/
@@ -96,6 +96,7 @@
          ${misc:Depends},
          ${python3:Depends},
          ${shlibs:Depends}
+Recommends: python3-pyqt4
 Suggests: python3-h5py,
           python-vigra-doc
 Description: Python3 bindings for the C++ computer vision library

=== debian/rules ===
--- 
+++ 
@@ -104,11 +104,5 @@
 		html/index.html
 endif
 
-override_dh_installdocs-indep:
-	dh_installdocs
-	# Cannot use dh $@ --with sphinxdoc since it is only available on
-	# arch-all builds.
-	dh_sphinxdoc
-
 %:
-	dh $@ --with python3,numpy3 --builddirectory=$(MAINBDIR) --no-parallel
+	dh $@ --builddirectory=$(MAINBDIR)

=== debian/watch ===
version=4
opts=uversionmangle=s/-/./g,\
dversionmangle=s/\+dfsg\d*$//,\
repacksuffix=+dfsg \
https://github.com/ukoethe/vigra/releases (?:.*/)Version-([\d-]+).tar.gz
